# Coverage for Doctrine_Sequence_Mysql

Back to coverage report

1 | <?php
2 | /*
3 | * $Id: Mysql.php 2963 2007-10-21 06:23:59Z Jonathan.Wage $
4 | *
5 | * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
6 | * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
7 | * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
8 | * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
9 | * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
10 | * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
11 | * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
12 | * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
13 | * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
14 | * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
15 | * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
16 | *
17 | * This software consists of voluntary contributions made by many individuals
18 | * and is licensed under the LGPL. For more information, see
19 | * <http://www.phpdoctrine.org>.
20 | */
21 | Doctrine::autoload('Doctrine_Sequence');
22 | /**
23 | * Doctrine_Sequence_Mysql
24 | *
25 | * @package Doctrine
26 | * @subpackage Sequence
27 | * @author Konsta Vesterinen <kvesteri@cc.hut.fi>
28 | * @license http://www.opensource.org/licenses/lgpl-license.php LGPL
29 | * @link www.phpdoctrine.org
30 | * @since 1.0
31 | * @version $Revision: 2963 $
32 | */
33 | class Doctrine_Sequence_Mysql extends Doctrine_Sequence
34 | {
35 | /**
36 | * Returns the next free id of a sequence
37 | *
38 | * @param string $seqName name of the sequence
39 | * @param bool when true missing sequences are automatic created
40 | *
41 | * @return integer next id in the given sequence
42 | */
43 | public function nextId($seqName, $onDemand = true)
44 | {
45 | $sequenceName = $this->conn->quoteIdentifier($this->conn->formatter->getSequenceName($seqName), true);
46 | $seqcolName = $this->conn->quoteIdentifier($this->conn->getAttribute(Doctrine::ATTR_SEQCOL_NAME), true);
47 | $query = 'INSERT INTO ' . $sequenceName . ' (' . $seqcolName . ') VALUES (NULL)';
48 |
49 | try {
50 |
51 | $this->conn->exec($query);
52 |
53 | } catch(Doctrine_Connection_Exception $e) {
54 | if ($onDemand && $e->getPortableCode() == Doctrine::ERR_NOSUCHTABLE) {
55 | // Since we are creating the sequence on demand
56 | // we know the first id = 1 so initialize the
57 | // sequence at 2
58 | try {
59 | $result = $this->conn->export->createSequence($seqName, 2);
60 | } catch(Doctrine_Exception $e) {
61 | throw new Doctrine_Sequence_Exception('on demand sequence ' . $seqName . ' could not be created');
62 | }
63 | // First ID of a newly created sequence is 1
64 | return 1;
65 | }
66 | throw $e;
67 | }
68 |
69 | $value = $this->lastInsertId();
70 |
71 | if (is_numeric($value)) {
72 | $query = 'DELETE FROM ' . $sequenceName . ' WHERE ' . $seqcolName . ' < ' . $value;
73 | $this->conn->exec($query);
74 | /**
75 | TODO: is the following needed ?
76 | if (PEAR::isError($result)) {
77 | $this->warnings[] = 'nextID: could not delete previous sequence table values from '.$seq_name;
78 | }
79 | */
80 | }
81 | return $value;
82 | }
83 |
84 | /**
85 | * Returns the autoincrement ID if supported or $id or fetches the current
86 | * ID in a sequence called: $table.(empty($field) ? '' : '_'.$field)
87 | *
88 | * @param string name of the table into which a new row was inserted
89 | * @param string name of the field into which a new row was inserted
90 | * @return integer|boolean
91 | */
92 | public function lastInsertId($table = null, $field = null)
93 | {
94 | return $this->conn->getDbh()->lastInsertId();
95 | }
96 |
97 | /**
98 | * Returns the current id of a sequence
99 | *
100 | * @param string $seqName name of the sequence
101 | *
102 | * @return integer current id in the given sequence
103 | */
104 | public function currId($seqName)
105 | {
106 | $sequenceName = $this->conn->quoteIdentifier($this->conn->formatter->getSequenceName($seqName), true);
107 | $seqcolName = $this->conn->quoteIdentifier($this->conn->getAttribute(Doctrine::ATTR_SEQCOL_NAME), true);
108 | $query = 'SELECT MAX(' . $seqcolName . ') FROM ' . $sequenceName;
109 |
110 | return (int) $this->conn->fetchOne($query);
111 | }
112 | }